import _regeneratorRuntime from 'babel-runtime/regenerator';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp, _initialiseProps;

var _templateObject = _taggedTemplateLiteralLoose(['', ''], ['', '']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';

import PropTypes from 'prop-types';

import Context from "@prisma-cms/context";

import gql from 'graphql-tag';

import { ApolloProvider } from 'react-apollo';
import { ApolloClient } from 'apollo-client';

// import { createUploadLink } from 'apollo-upload-client'
import { createUploadLink } from '../external/apollo-upload-client';

import { InMemoryCache } from 'apollo-cache-inmemory';
import { ApolloLink, from } from 'apollo-link';
import { onError } from 'apollo-link-error';
// import { createHttpLink } from "apollo-link-http";

import { WebSocketLink } from 'apollo-link-ws';
import { split } from 'apollo-link';
import { getMainDefinition } from 'apollo-utilities';

import Renderer from './Renderer';
// import { HttpLink } from 'apollo-boost/lib/bundle.umd';


var ApolloCmsApp = (_temp = _class = function (_React$Component) {
  _inherits(ApolloCmsApp, _React$Component);

  function ApolloCmsApp(props) {
    _classCallCheck(this, ApolloCmsApp);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var _this$props = _this.props,
        endpoint = _this$props.endpoint,
        _this$props$credentia = _this$props.credentials,
        credentials = _this$props$credentia === undefined ? 'same-origin' : _this$props$credentia,
        localStorage = _this$props.localStorage;


    if (!endpoint) {
      throw new Error("Endpoind required");
    }

    var authMiddleware = new ApolloLink(function (operation, forward) {
      // eslint-disable-line react/prefer-stateless-function
      // add the authorization to the headers
      operation.setContext(function (_ref) {
        var _ref$headers = _ref.headers,
            headers = _ref$headers === undefined ? {} : _ref$headers;
        return {
          headers: _extends({}, headers, {
            Authorization: localStorage && localStorage.getItem('token') || null
          })
        };
      });

      return forward(operation);
    });

    var wsLink = void 0;

    var httpLink = createUploadLink({
      uri: endpoint,
      credentials: credentials
    });

    // const httpLink = createHttpLink({ 
    //   uri: endpoint,
    // });

    wsLink = new WebSocketLink({
      uri: endpoint.replace(/^http/, 'ws'),
      options: {
        reconnect: true,
        connectionParams: function connectionParams() {
          return {
            Authorization: localStorage && localStorage.token || undefined
          };
        }
      }
    });

    var _wsLink = wsLink,
        subscriptionClient = _wsLink.subscriptionClient;

    // console.log("App wsClient subscriptionClient", subscriptionClient);

    _this.prepareSubscriptionClient(subscriptionClient);

    global.wsLink = wsLink;

    var wsHttpLink = split(
    // split based on operation type
    function (request) {
      var query = request.query;

      var _getMainDefinition = getMainDefinition(query),
          kind = _getMainDefinition.kind,
          operation = _getMainDefinition.operation;

      return kind === 'OperationDefinition' && operation === 'subscription';
    }, wsLink, httpLink);

    var errorLink = onError(_this.onError);

    var link = errorLink.concat(wsHttpLink);
    // const link = errorLink.concat(httpLink);

    var client = new ApolloClient({
      link: from([authMiddleware, link]),
      cache: new InMemoryCache().restore(global.__APOLLO_STATE__),
      connectToDevTools: true
    });

    _this.state = {
      client: client,
      errors: [],
      wsLink: wsLink
    };

    return _this;
  } // eslint-disable-line react/prefer-stateless-function


  ApolloCmsApp.prototype.prepareSubscriptionClient = function prepareSubscriptionClient(client) {

    // client.onConnecting((e) => {
    //   console.log(`App wsClient onConnecting`, e, client.status);
    // });

    // client.onConnected((e) => {
    //   console.log(`App wsClient onConnected`, e, client.status);
    // });

    // client.onDisconnected((e) => {
    //   console.log(`App wsClient onDisconnected`, e, client.status);
    // });

    // client.onError((e, error) => {
    //   console.log(`App wsClient onError`, e, error, client.status);
    // });

    // client.onReconnecting((e) => {
    //   console.log(`App wsClient onReconnecting`, e, client.status);
    // });

    // client.onReconnected((e) => {
    //   console.log(`App wsClient onReconnected`, e, client.status);
    // });

  };

  ApolloCmsApp.prototype.getChildContext = function getChildContext() {
    var _this2 = this;

    var _state = this.state,
        token = _state.token,
        user = _state.user,
        errors = _state.errors;
    var localStorage = this.props.localStorage;


    var context = {
      token: token,
      user: user,
      onAuthSuccess: function onAuthSuccess(data) {
        return _this2.onAuthSuccess(data);
      },
      loadApiData: function loadApiData() {
        return _this2.loadApiData();
      },
      logout: function logout() {
        return _this2.logout();
      },
      errors: errors,
      localStorage: localStorage
    };

    return context;
  };

  ApolloCmsApp.prototype.onAuthSuccess = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(data) {
      var _this3 = this;

      var token, user, localStorage, client;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              token = data.token, user = data.user;
              localStorage = this.props.localStorage;
              client = this.state.client;


              token && localStorage.setItem("token", 'Bearer ' + token);

              // setTimeout(async () => {
              // }, 1000);


              this.setState({
                user: user
              }, _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                return _regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return client.resetStore();

                      case 2:

                        _this3.reconnectWs();

                        // this.forceUpdate();


                      case 3:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this3);
              })));

            case 5:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function onAuthSuccess(_x) {
      return _ref2.apply(this, arguments);
    }

    return onAuthSuccess;
  }();

  ApolloCmsApp.prototype.logout = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
      var _this4 = this;

      var localStorage, client;
      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              localStorage = this.props.localStorage;
              client = this.state.client;


              localStorage.setItem("token", '');

              this.setState({
                user: null
              }, _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return client.resetStore();

                      case 2:

                        _this4.reconnectWs();

                      case 3:
                      case 'end':
                        return _context3.stop();
                    }
                  }
                }, _callee3, _this4);
              })));

            case 4:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function logout() {
      return _ref4.apply(this, arguments);
    }

    return logout;
  }();

  // subscribe = (options, observer) => {

  //   const {
  //     wsLink,
  //   } = this.state;

  // }


  ApolloCmsApp.prototype.componentDidMount = function componentDidMount() {

    this.loadApiData();
  };

  ApolloCmsApp.prototype.loadApiData = function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
      var apiQuery, client, result, _ref7, data;

      return _regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              apiQuery = this.props.apiQuery;

              if (apiQuery) {
                _context5.next = 3;
                break;
              }

              return _context5.abrupt('return', false);

            case 3:
              client = this.state.client;
              _context5.next = 6;
              return client.query({
                query: gql(_templateObject, apiQuery),
                fetchPolicy: "network-only"
              }, {}).then(function (r) {
                return r;
              }).catch(function (e) {
                console.error(e);
              });

            case 6:
              result = _context5.sent;
              _ref7 = result || {}, data = _ref7.data;


              if (data) {
                this.setState(_extends({}, data));
              }

              return _context5.abrupt('return', result);

            case 10:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function loadApiData() {
      return _ref6.apply(this, arguments);
    }

    return loadApiData;
  }();

  ApolloCmsApp.prototype.render = function render() {
    var _this5 = this;

    var _state2 = this.state,
        client = _state2.client,
        errors = _state2.errors,
        wsLink = _state2.wsLink;

    var _props = this.props,
        Renderer = _props.Renderer,
        localStorage = _props.localStorage,
        other = _objectWithoutProperties(_props, ['Renderer', 'localStorage']);

    return React.createElement(
      ApolloProvider,
      {
        client: client
      },
      React.createElement(
        Context.Consumer,
        null,
        function (context) {

          return React.createElement(
            Context.Provider,
            {
              value: Object.assign(context, _extends({
                client: client,
                errors: errors,
                wsLink: wsLink,
                reconnectWs: _this5.reconnectWs
              }, _this5.getChildContext()))
            },
            React.createElement(Renderer, other)
          );
        }
      )
    );
  };

  return ApolloCmsApp;
}(React.Component), _class.defaultProps = {
  Renderer: Renderer,
  apiQuery: '{\n      user:me{\n        id\n        username\n      }\n    }',
  localStorage: global.localStorage
}, _class.childContextTypes = {
  onAuthSuccess: PropTypes.func,
  loadApiData: PropTypes.func,
  logout: PropTypes.func,
  token: PropTypes.string,
  user: PropTypes.object,
  errors: PropTypes.array,
  localStorage: PropTypes.object
}, _initialiseProps = function _initialiseProps() {
  var _this6 = this;

  this.reconnectWs = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
    var wsLink, _ref9, subscriptionClient;

    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            wsLink = _this6.state.wsLink;
            _ref9 = wsLink || {}, subscriptionClient = _ref9.subscriptionClient;

            // console.log("reconnectWs subscriptionClient status", subscriptionClient.status);

            if (subscriptionClient) {
              // subscriptionClient.unsubscribeAll();
              subscriptionClient.close(false, false);
            }

          case 3:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, _this6);
  }));

  this.onError = function (response) {
    var networkError = response.networkError,
        graphQLErrors = response.graphQLErrors,
        _response$messageDela = response.messageDelay,
        messageDelay = _response$messageDela === undefined ? 5000 : _response$messageDela;


    if (networkError && networkError.statusCode === 401) {
      ;
    }

    graphQLErrors && graphQLErrors.map(function (n) {
      var _ref10 = n || {},
          message = _ref10.message;

      var _state$errors = _this6.state.errors,
          errors = _state$errors === undefined ? [] : _state$errors;


      if (message) {

        var error = {
          message: message
        };

        errors.push(error);

        setTimeout(function () {
          var errors = _this6.state.errors;


          var index = errors && errors.indexOf(error);

          if (index !== -1) {

            errors.splice(index, 1);

            _this6.setState({
              errors: errors
            });
          }
        }, messageDelay);
      }

      if (errors && errors.length) {

        _this6.setState({
          errors: errors
        });
      }

      return n;
    });

    return;
  };
}, _temp);
export { ApolloCmsApp as default };
ApolloCmsApp.propTypes = process.env.NODE_ENV !== "production" ? {
  endpoint: PropTypes.string.isRequired,
  Renderer: PropTypes.func.isRequired,
  apiQuery: PropTypes.string,
  localStorage: PropTypes.object.isRequired
} : {};