function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Tooltip, IconButton, Menu, ListItem } from 'material-ui';

import ChoseColumnsIcon from 'material-ui-icons/MoreVert';
import { MenuItem } from 'material-ui';
import { ListItemText } from 'material-ui';
import { ListItemSecondaryAction } from 'material-ui';
import { Switch } from 'material-ui';
import { withStyles } from 'material-ui';

export var styles = {

  root: {}
};

export var TableViewChoseColumns = function (_Component) {
  _inherits(TableViewChoseColumns, _Component);

  function TableViewChoseColumns() {
    var _temp, _this, _ret;

    _classCallCheck(this, TableViewChoseColumns);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      anchorEl: null
    }, _this.handleClick = function (event) {
      _this.setState({ anchorEl: event.currentTarget });
    }, _this.handleClose = function () {
      _this.setState({ anchorEl: null });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TableViewChoseColumns.prototype.render = function render() {
    var _props = this.props,
        classes = _props.classes,
        columnData = _props.columnData,
        toggleColumnVisibility = _props.toggleColumnVisibility;


    if (!columnData || !columnData.length) {
      return null;
    }

    var ITEM_HEIGHT = 48;

    var anchorEl = this.state.anchorEl;


    var columns = [];

    columnData.map(function (n, index) {
      var id = n.id,
          label = n.label,
          description = n.description,
          hidden = n.hidden;


      if (hidden === undefined) {
        return;
      }

      var textPrimary = label || id;

      var checked = hidden === true ? false : true;

      columns.push(React.createElement(
        ListItem,
        {
          key: index,
          dense: true,
          button: true,
          onClick: function onClick(event) {
            return toggleColumnVisibility(event, !checked, index);
          }
        },
        React.createElement(Switch
        // onChange={(event, checked) => toggleColumnVisibility(event, checked, index)}
        , { checked: checked
        }),
        React.createElement(ListItemText, {
          primary: textPrimary,
          secondary: description
        })
      ));
    });

    if (!columns || !columns.length) {
      return null;
    }

    return React.createElement(
      'div',
      null,
      React.createElement(
        IconButton,
        {
          'aria-label': 'More',
          'aria-owns': anchorEl ? 'long-menu' : null,
          'aria-haspopup': 'true',
          onClick: this.handleClick
        },
        React.createElement(ChoseColumnsIcon, null)
      ),
      React.createElement(
        Menu,
        {
          id: 'long-menu',
          anchorEl: anchorEl,
          open: Boolean(anchorEl),
          onClose: this.handleClose,
          PaperProps: {
            style: {
              maxHeight: ITEM_HEIGHT * 4.5,
              minWidth: 200,
              maxWidth: 350
            }
          }
        },
        columns
      )
    );

    return React.createElement(
      Tooltip,
      { title: '\u0412\u044B\u0431\u0440\u0430\u0442\u044C \u043A\u043E\u043B\u043E\u043D\u043A\u0438' },
      React.createElement(
        IconButton
        // aria-label="AddPlace"
        // onClick={addObject}
        ,
        null,
        React.createElement(ChoseColumnsIcon, null)
      )
    );
  };

  return TableViewChoseColumns;
}(Component);

TableViewChoseColumns.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: PropTypes.object.isRequired,
  columnData: PropTypes.array.isRequired,
  toggleColumnVisibility: PropTypes.func.isRequired
} : {};
export default withStyles(styles)(function (props) {
  return React.createElement(TableViewChoseColumns, props);
});