var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import Grid from "material-ui/Grid";
import TextField from "material-ui/TextField";
import Checkbox from "material-ui/Checkbox";
import Button from "material-ui/Button";

import { styles, TableView } from "../../../../DataView/List/Table";

import withStyles from 'material-ui/styles/withStyles';

export var edges = [{
  "node": {
    "id": "cjn27lkhv08sp0950dcfp61c3",
    "username": "Test",
    "fullname": "",
    "image": null,
    "sudo": false,
    "email": "test@localhost",
    "__typename": "User"
  },
  "__typename": "UserEdge"
}, {
  "node": {
    "id": "cjn29andg08zb0950gba9l3yo",
    "username": "test",
    "fullname": null,
    "image": null,
    "sudo": false,
    "__typename": "User"
  },
  "__typename": "UserEdge"
}];

export var count = edges.length;

export var limit = 1;

export var data = {
  "variables": {
    "first": 10,
    "skip": 0,
    "orderBy": "username_ASC",
    "where": null
  },
  "loading": false,
  "networkStatus": 7,
  "objectsConnection": {
    "pageInfo": {
      "hasNextPage": false,
      "hasPreviousPage": false,
      "startCursor": "cjn27lkhv08sp0950dcfp61c3",
      "endCursor": "cjn29b63508zn09504gf24kde",
      "__typename": "PageInfo"
    },
    "aggregate": {
      "count": count,
      "__typename": "AggregateUser"
    },
    "edges": edges,
    "__typename": "UserConnection"
  }
};

export var DevTableView = (_temp = _class = function (_TableView) {
  _inherits(DevTableView, _TableView);

  function DevTableView(props) {
    _classCallCheck(this, DevTableView);

    var _this = _possibleConstructorReturn(this, _TableView.call(this, props));

    _this.state = _extends({}, _this.state, {
      columnData: [{
        id: "id",
        label: "ID",
        hidden: true
      }, {
        id: "username",
        label: "Username",
        description: "Unique username",
        hidden: false,
        renderer: function renderer(value) {
          return React.createElement(
            'span',
            {
              className: 'username'
            },
            value
          );
        }
      }, {
        id: "email",
        label: "Email",
        hidden: false,
        renderer: function renderer(value) {
          return value ? React.createElement(
            'a',
            {
              href: 'mailto:' + value
            },
            value
          ) : null;
        }
      }]
    });
    return _this;
  }

  DevTableView.prototype.renderFilters = function renderFilters() {
    var _this2 = this;

    _objectDestructuringEmpty(this.props);

    var _ref = this.getFilters() || {},
        query = _ref.query,
        advantages_not = _ref.advantages_not,
        with_employes = _ref.with_employes;

    var filters = React.createElement(
      Grid,
      {
        container: true,
        spacing: 8,
        alignItems: 'center'
      },
      React.createElement(
        Grid,
        {
          item: true
        },
        React.createElement(TextField, {
          label: '\u041F\u043E\u0438\u0441\u043A',
          style: {
            marginLeft: 10,
            width: 200
          },
          name: 'query',
          value: query || "",
          onChange: function onChange(event) {
            var value = event.target.value;


            _this2.setFilters({
              query: value
            });
          },
          inputProps: {
            className: "searchInput"
          }
        })
      ),
      React.createElement(
        Grid,
        {
          item: true
        },
        React.createElement(
          Grid,
          {
            container: true,
            alignItems: 'center'
          },
          React.createElement(
            Grid,
            {
              item: true
            },
            React.createElement(Checkbox, {
              checked: advantages_not === null ? true : false,
              bool: 'true',
              onChange: function onChange(event, checked) {
                // const {
                //   value,
                // } = event.target;

                _this2.setFilters({
                  advantages_not: checked ? null : undefined
                });
              }
            })
          ),
          React.createElement(
            Grid,
            {
              item: true
            },
            '\u0421 \u043F\u0440\u0435\u0438\u043C\u0443\u0449\u0435\u0441\u0442\u0432\u0430\u043C\u0438'
          )
        )
      ),
      React.createElement(
        Grid,
        {
          item: true
        },
        React.createElement(
          Grid,
          {
            container: true,
            alignItems: 'center'
          },
          React.createElement(
            Grid,
            {
              item: true
            },
            React.createElement(Checkbox, {
              checked: with_employes === true ? true : false,
              bool: 'true',
              onChange: function onChange(event, checked) {
                _this2.setFilters({
                  with_employes: checked ? true : undefined
                });
              }
            })
          ),
          React.createElement(
            Grid,
            {
              item: true
            },
            '\u0421 \u0441\u043E\u0442\u0440\u0443\u0434\u043D\u0438\u043A\u0430\u043C\u0438'
          )
        )
      ),
      React.createElement(
        Grid,
        {
          item: true
        },
        React.createElement(
          Button,
          {
            onClick: function onClick(event) {
              return _this2.cleanFilters({
                // where: null,
                // extraWhere: null,
              });
            }
          },
          '\u0421\u0431\u0440\u043E\u0441'
        )
      )
    );

    return filters;
  };

  DevTableView.prototype.getColumns = function getColumns() {
    var columnData = this.state.columnData;


    return columnData || [];
  };

  return DevTableView;
}(TableView), _class.defaultProps = _extends({}, TableView.defaultProps, {
  data: data,
  title: "Test",
  limit: limit

}), _temp);

export { styles, DevTableView as TableView };

export default withStyles(styles)(function (props) {
  return React.createElement(DevTableView, props);
});