'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Table = require('material-ui/Table');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TBody = function (_Component) {
  _inherits(TBody, _Component);

  function TBody() {
    _classCallCheck(this, TBody);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  TBody.prototype.render = function render() {
    var _props = this.props,
        data = _props.data,
        columnData = _props.columnData;


    return _react2.default.createElement(
      _Table.TableBody,
      null,
      data.map(function (n) {
        var id = n.id;


        var columns = columnData.filter(function (n) {
          return n.hidden !== true;
        }).map(function (record, index) {
          var fieldName = record.id,
              label = record.label,
              disablePadding = record.disablePadding,
              padding = record.padding,
              numeric = record.numeric,
              renderer = record.renderer,
              other = _objectWithoutProperties(record, ['id', 'label', 'disablePadding', 'padding', 'numeric', 'renderer']);

          var value = n[fieldName];

          return _react2.default.createElement(
            _Table.TableCell,
            _extends({
              key: index,
              padding: disablePadding === true ? "none" : padding
            }, other),
            renderer ? renderer(value, n) : value || ""
          );
        });

        return _react2.default.createElement(
          _Table.TableRow,
          {
            key: id,
            hover: true,
            tabIndex: -1
          },
          columns
        );
      })
    );
  };

  return TBody;
}(_react.Component);

exports.default = TBody;
TBody.propTypes = process.env.NODE_ENV !== "production" ? {
  data: _propTypes2.default.array.isRequired,
  columnData: _propTypes2.default.array.isRequired
} : {};
module.exports = exports['default'];