'use strict';

exports.__esModule = true;
exports.ExportToExcel = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CloudDownload = require('material-ui-icons/CloudDownload');

var _CloudDownload2 = _interopRequireDefault(_CloudDownload);

var _materialUi = require('material-ui');

var _excellentexport = require('excellentexport');

var _excellentexport2 = _interopRequireDefault(_excellentexport);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// export const styles = theme => {

//   console.log("theme", theme);

//   const {
//     palette: {
//       action,
//     },
//   } = theme;

//   return {
//     link: {
//       color: action.active,
//       "&:hover": {
//         color: action.hover,
//       },
//     },
//   }
// }

var ExportToExcel = exports.ExportToExcel = (_temp = _class = function (_Component) {
  _inherits(ExportToExcel, _Component);

  function ExportToExcel() {
    _classCallCheck(this, ExportToExcel);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ExportToExcel.prototype.exportTable = function exportTable(event) {
    var _props = this.props,
        table = _props.table,
        filename = _props.filename,
        format = _props.format,
        sheetName = _props.sheetName,
        includeHeaders = _props.includeHeaders;


    var anchor = event.currentTarget;

    filename += '_' + (0, _moment2.default)().format('DD.MM.YYYY-HH:mm:ss');

    // console.log("exportExcel event", { ...event });

    // console.log("exportExcel anchor", anchor);


    // console.log("exportExcel table", table);

    var options = {
      // anchor: 'anchor',
      anchor: anchor,
      filename: filename,
      format: format,
      sheetName: sheetName
    };

    var sheets = [];

    var data = [];

    var rows = [];

    if (includeHeaders) {

      var theadRows = table.querySelector("thead").children;

      for (var _iterator = theadRows, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var item = _ref;

        rows.push(item);
      }
    }

    // rows = rows.concat(table.querySelector("tbody").children);

    var tbodyRows = table.querySelector("tbody").children;

    for (var _iterator2 = tbodyRows, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
      var _ref2;

      if (_isArray2) {
        if (_i2 >= _iterator2.length) break;
        _ref2 = _iterator2[_i2++];
      } else {
        _i2 = _iterator2.next();
        if (_i2.done) break;
        _ref2 = _i2.value;
      }

      var row = _ref2;

      rows.push(row);
    }

    // const table2 = window.document.querySelector("table");

    // console.log("table", table);
    // console.log("table2", table2);

    // console.log("table === table2", table === table2);


    // console.log("table rows", rows, { ...rows });

    rows.map(function (row) {

      var values = [];

      // console.log("cols parent", row, { ...row });


      var cols = row.children;

      // console.log("cols", cols);

      for (var _iterator3 = cols, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
        var _ref3;

        if (_isArray3) {
          if (_i3 >= _iterator3.length) break;
          _ref3 = _iterator3[_i3++];
        } else {
          _i3 = _iterator3.next();
          if (_i3.done) break;
          _ref3 = _i3.value;
        }

        var col = _ref3;


        values.push(col ? col.textContent : "");
      }

      data.push(values);
    });

    // if (format === "csv") {

    sheets = [{
      name: sheetName,
      from: {
        // array: [
        //   [1, 2, 3],
        //   ['hello', '2200', 'bye'],
        //   ['quo"te', 'dobl"e qu"ote', 'singl\'e quote']
        // ]
        array: data
      }
    }];

    // console.log("data", data);

    // return false;

    var workbook = _excellentexport2.default.convert(options, sheets);

    // console.log(workbook, 'Result must not be null');


    // const anchor = document.getElementById('datatable');
    // const anchor = document.getElementById('datatable');
    // console.log(anchor.href, 'Element must have href');
    // console.log(anchor.href.indexOf('blob:') === 0, 'Element href myst be a blob:');

    return workbook;
  };

  ExportToExcel.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        columnData = _props2.columnData,
        filename = _props2.filename,
        format = _props2.format,
        table = _props2.table,
        sheetName = _props2.sheetName,
        includeHeaders = _props2.includeHeaders,
        other = _objectWithoutProperties(_props2, ['columnData', 'filename', 'format', 'table', 'sheetName', 'includeHeaders']);

    if (!table) {
      return;
    }

    return _react2.default.createElement(
      _materialUi.IconButton,
      _extends({
        href: 'javascript:;',
        component: 'a'
        // download={`${filename}.${format}`}
        , onClick: function onClick(event) {
          return _this2.exportTable(event);
        }
        // className={classes.link}
      }, other),
      _react2.default.createElement(_CloudDownload2.default, null)
    );
  };

  return ExportToExcel;
}(_react.Component), _class.defaultProps = {
  format: "xlsx",
  filename: "Export",
  sheetName: "Sheet 1",
  includeHeaders: true
}, _temp);
ExportToExcel.propTypes = process.env.NODE_ENV !== "production" ? {
  // classes: PropTypes.object.isRequired,
  table: _propTypes2.default.instanceOf(HTMLTableElement).isRequired,
  format: _propTypes2.default.oneOf(["csv", "xls", "xlsx"]).isRequired,
  filename: _propTypes2.default.string.isRequired,
  columnData: _propTypes2.default.array.isRequired,
  sheetName: _propTypes2.default.string.isRequired,
  includeHeaders: _propTypes2.default.bool.isRequired
} : {};
exports.default = ExportToExcel;

// export default withStyles(styles)(props => <ExportToExcel
//   {...props}
// />);