'use strict';

exports.__esModule = true;
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;
// import Grid from 'material-ui/Grid';


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _ModeEdit = require('material-ui-icons/ModeEdit');

var _ModeEdit2 = _interopRequireDefault(_ModeEdit);

var _Restore = require('material-ui-icons/Restore');

var _Restore2 = _interopRequireDefault(_Restore);

var _Save = require('material-ui-icons/Save');

var _Save2 = _interopRequireDefault(_Save);

var _Snackbar = require('material-ui/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _Progress = require('material-ui/Progress');

var _ = require('../');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SaveIcon = function SaveIcon() {

  return _react2.default.createElement(_Save2.default, {
    style: {
      color: "red"
    }
  });
};

var EditableView = (_temp = _class = function (_View) {
  _inherits(EditableView, _View);

  function EditableView(props) {
    _classCallCheck(this, EditableView);

    var _this = _possibleConstructorReturn(this, _View.call(this, props));

    _objectDestructuringEmpty(props);

    _this.state = {
      inEditMode: false,
      notifications: [],
      loading: false
    };

    return _this;
  }

  EditableView.prototype.componentWillMount = function componentWillMount() {
    var _props$_dirty = this.props._dirty,
        _dirty = _props$_dirty === undefined ? null : _props$_dirty;

    var cache = this.getCache();

    Object.assign(this.state, {
      _dirty: _dirty || cache ? _extends({}, _dirty, cache) : undefined
    });

    return _View.prototype.componentWillMount ? _View.prototype.componentWillMount.call(this) : true;
  };

  EditableView.prototype.getCacheKey = function getCacheKey() {
    var _props = this.props,
        cacheKey = _props.cacheKey,
        cacheKeyPrefix = _props.cacheKeyPrefix;

    var _ref = this.getObject() || {},
        id = _ref.id;

    return cacheKey !== undefined ? cacheKey : id ? '' + cacheKeyPrefix + id : null;
  };

  EditableView.prototype.setCache = function setCache(data) {
    var localStorage = this.context.localStorage;


    if (!localStorage) {
      return false;
    }

    var cacheData = void 0;

    var key = this.getCacheKey();

    if (key) {
      try {

        if (data) {
          cacheData = JSON.stringify(data);
          localStorage.setItem(key, cacheData);
        } else {
          localStorage.removeItem(key);
        }
      } catch (error) {}
    }
  };

  EditableView.prototype.getCache = function getCache() {
    var localStorage = this.context.localStorage;


    var cacheData = void 0;

    var key = this.getCacheKey();

    if (key && localStorage) {
      try {

        cacheData = localStorage.getItem(key);

        if (cacheData) {
          cacheData = JSON.parse(cacheData);
        }
      } catch (error) {}
    }

    // console.log("getCacheKey", cacheData);

    return cacheData;
  };

  EditableView.prototype.clearCache = function clearCache() {
    var localStorage = this.context.localStorage;


    var key = this.getCacheKey();

    if (key && localStorage) {
      localStorage.removeItem(key);
    }
  };

  EditableView.prototype.save = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
      var _this2 = this;

      var _state, _dirty, loading, client;

      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _state = this.state, _dirty = _state._dirty, loading = _state.loading;
              client = this.context.client;

              if (!loading) {
                _context3.next = 4;
                break;
              }

              return _context3.abrupt('return');

            case 4:
              return _context3.abrupt('return', new Promise(function (resolve, reject) {

                _this2.setState({
                  loading: true
                }, _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
                  var newState, result;
                  return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          newState = {
                            loading: false
                          };
                          _context2.next = 3;
                          return _this2.saveObject(_dirty).then(function () {
                            var _ref4 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(result) {
                              var _ref5, resultData, _ref6, response, _ref7, success, message, _ref7$errors, errors, other, onSave;

                              return _regenerator2.default.wrap(function _callee$(_context) {
                                while (1) {
                                  switch (_context.prev = _context.next) {
                                    case 0:
                                      if (!(result instanceof Error)) {
                                        _context.next = 3;
                                        break;
                                      }

                                      _context.next = 20;
                                      break;

                                    case 3:
                                      _ref5 = result || {}, resultData = _ref5.data;
                                      _ref6 = resultData || {}, response = _ref6.response;

                                      // console.log("result", result);
                                      // console.log("resultData", resultData);

                                      _ref7 = response || {}, success = _ref7.success, message = _ref7.message, _ref7$errors = _ref7.errors, errors = _ref7$errors === undefined ? null : _ref7$errors, other = _objectWithoutProperties(_ref7, ['success', 'message', 'errors']);


                                      Object.assign(newState, {
                                        errors: errors
                                      });

                                      if (success === undefined) {

                                        success = true;
                                      }

                                      if (success) {
                                        _context.next = 12;
                                        break;
                                      }

                                      _this2.addError(message || "Request error");

                                      // errors && errors.map(error => {
                                      //   this.addError(error);
                                      // });

                                      _context.next = 20;
                                      break;

                                    case 12:

                                      Object.assign(newState, {
                                        _dirty: null,
                                        inEditMode: false
                                      });

                                      _this2.clearCache();

                                      // await client.resetStore();
                                      // await client.cache.reset();
                                      // console.log("client.cache.clearStore");
                                      _context.next = 16;
                                      return client.clearStore().catch(console.error);

                                    case 16:
                                      _context.next = 18;
                                      return client.reFetchObservableQueries().catch(console.error);

                                    case 18:
                                      onSave = _this2.props.onSave;


                                      if (onSave) {
                                        onSave(result);
                                      }

                                    case 20:
                                      return _context.abrupt('return', result);

                                    case 21:
                                    case 'end':
                                      return _context.stop();
                                  }
                                }
                              }, _callee, _this2);
                            }));

                            return function (_x) {
                              return _ref4.apply(this, arguments);
                            };
                          }()).catch(function (e) {
                            console.error(e);
                            return e;
                          });

                        case 3:
                          result = _context2.sent;


                          _this2.setState(newState, function () {
                            return resolve(result);
                          });

                          return _context2.abrupt('return');

                        case 6:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _callee2, _this2);
                })));
              }));

            case 5:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function save() {
      return _ref2.apply(this, arguments);
    }

    return save;
  }();

  EditableView.prototype.saveObject = function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee4(data) {
      var mutate, mutation, result;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:

              // const {
              //   object,
              //   saveObject,
              // } = this.props;

              // if(saveObject){
              //   return saveObject(data);
              // }

              // console.log("saveObject data", data);

              mutate = this.props.mutate;

              if (mutate) {
                _context4.next = 3;
                break;
              }

              throw new Error("Mutate not defined");

            case 3:
              mutation = this.getMutation(data);
              _context4.next = 6;
              return mutate(mutation).then(function (r) {
                return r;
              }).catch(function (e) {

                // throw (e);
                return e;
              });

            case 6:
              result = _context4.sent;
              return _context4.abrupt('return', result);

            case 8:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function saveObject(_x2) {
      return _ref8.apply(this, arguments);
    }

    return saveObject;
  }();

  EditableView.prototype.getMutation = function getMutation(data) {

    var variables = this.getMutationVariables(data);

    return {
      variables: variables
    };
  };

  EditableView.prototype.getMutationVariables = function getMutationVariables(data) {

    var object = this.getObjectWithMutations();

    var _ref9 = object || {},
        id = _ref9.id;

    var where = id ? { id: id } : undefined;

    return {
      where: where,
      data: data
    };
  };

  EditableView.prototype.startEdit = function startEdit() {

    this.setState({
      inEditMode: true
    });
  };

  EditableView.prototype.resetEdit = function resetEdit() {
    var _this3 = this;

    return new Promise(function (resolve) {
      _this3.clearCache();

      _this3.setState({
        inEditMode: false,
        _dirty: null
      }, resolve);
    });
  };

  EditableView.prototype.isInEditMode = function isInEditMode() {
    var _state2 = this.state,
        inEditMode = _state2.inEditMode,
        _dirty = _state2._dirty;


    return inEditMode || _dirty ? true : false;
  };

  EditableView.prototype.isDirty = function isDirty() {

    return this.state._dirty ? true : false;
  };

  EditableView.prototype.onChange = function onChange(event) {
    var _updateObject;

    var _event$target = event.target,
        name = _event$target.name,
        value = _event$target.value;

    // console.log("onChange", name, value);

    this.updateObject((_updateObject = {}, _updateObject[name] = value, _updateObject));
  };

  // updateObject(data) {

  //   const {
  //     _dirty = {},
  //   } = this.state;

  //   const {
  //     localStorage,
  //   } = this.context;

  //   const newData = Object.assign({ ..._dirty }, data);

  //   const key = this.getCacheKey();

  //   if (key && newData && localStorage) {

  //     localStorage.setItem(this.getCacheKey(), JSON.stringify(newData));
  //   }


  //   this.setState({
  //     _dirty: newData,
  //   });

  // }


  EditableView.prototype.updateObject = function updateObject(data) {
    var _state$_dirty = this.state._dirty,
        _dirty = _state$_dirty === undefined ? {} : _state$_dirty;

    var localStorage = this.context.localStorage;


    var newData = Object.assign(_extends({}, _dirty), data);

    var key = this.getCacheKey();

    if (key && newData && localStorage) {
      localStorage.setItem(this.getCacheKey(), JSON.stringify(newData));
    }

    this.state._dirty = newData;

    this.forceUpdate();
  };

  EditableView.prototype.getEditor = function getEditor(props) {
    var _this4 = this;

    var Editor = props.Editor,
        name = props.name,
        helperText = props.helperText,
        _onFocus = props.onFocus,
        _props$fullWidth = props.fullWidth,
        fullWidth = _props$fullWidth === undefined ? true : _props$fullWidth,
        other = _objectWithoutProperties(props, ['Editor', 'name', 'helperText', 'onFocus', 'fullWidth']);

    var object = this.getObjectWithMutations();

    if (!object) {
      return null;
    }

    var value = object[name] || "";

    var errors = this.state.errors;


    var error = errors ? errors.find(function (n) {
      return n.key === name;
    }) : "";

    return Editor ? _react2.default.createElement(Editor, _extends({
      onChange: function onChange(event) {
        _this4.onChange(event);
      },
      name: name,
      value: value,
      style: fullWidth ? {
        width: "100%"
      } : undefined,
      error: error ? true : false,
      helperText: error && error.message || helperText,
      onFocus: function onFocus(event) {

        if (error) {
          var index = errors.indexOf(error);
          if (index !== -1) {
            errors.splice(index, 1);
            _this4.setState({
              errors: errors
            });
          }
        }

        return _onFocus ? _onFocus(event) : null;
      },
      fullWidth: fullWidth
    }, other)) : null;
  };

  EditableView.prototype.getTextField = function getTextField() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


    props = _extends({
      Editor: _TextField2.default,
      autoComplete: "off"
    }, props);

    return this.getEditor(props);
  };

  EditableView.prototype.getObjectWithMutations = function getObjectWithMutations() {

    var object = this.getObject();

    if (!object) {
      return object;
    }

    var _dirty = this.state._dirty;


    if (_dirty) {

      var draftObject = _extends({}, object);

      return Object.assign(draftObject, _dirty);
    } else {
      return object;
    }
  };

  EditableView.prototype.getObject = function getObject() {
    var data = this.props.data;

    var _ref10 = data || {},
        object = _ref10.object;

    return object;
  };

  EditableView.prototype.getButtons = function getButtons() {
    var loading = this.state.loading;
    var SaveIcon = this.props.SaveIcon;


    var inEditMode = this.isInEditMode();

    var isDirty = this.isDirty();

    var buttons = [];

    if (this.canEdit()) {

      if (inEditMode) {

        buttons.push(this.renderResetButton());

        if (isDirty) {

          buttons.push(this.renderSaveButton());
        }
      } else {
        buttons.push(this.renderEditButton());
      }
    }

    return buttons && buttons.length ? buttons : null;
  };

  EditableView.prototype.renderResetButton = function renderResetButton() {
    var _this5 = this;

    var ResetIcon = this.props.ResetIcon;


    return _react2.default.createElement(
      _IconButton2.default,
      {
        key: 'reset',
        onClick: function onClick(event) {
          _this5.resetEdit();
        }
      },
      _react2.default.createElement(ResetIcon, null)
    );
  };

  EditableView.prototype.renderSaveButton = function renderSaveButton() {
    var _this6 = this;

    var SaveIcon = this.props.SaveIcon;
    var loading = this.state.loading;


    return _react2.default.createElement(
      _IconButton2.default,
      {
        key: 'save',
        onClick: function onClick(event) {
          _this6.save();
        },
        disabled: loading
      },
      loading ? _react2.default.createElement(_Progress.CircularProgress, null) : _react2.default.createElement(SaveIcon, null)
    );
  };

  EditableView.prototype.renderEditButton = function renderEditButton() {
    var _this7 = this;

    var EditIcon = this.props.EditIcon;


    return _react2.default.createElement(
      _IconButton2.default,
      {
        key: 'edit',
        onClick: function onClick(event) {
          _this7.startEdit();
        }
      },
      _react2.default.createElement(EditIcon, null)
    );
  };

  EditableView.prototype.getTitle = function getTitle() {

    // const {
    //   object,
    // } = this.props;

    var object = this.getObjectWithMutations();

    var _ref11 = object || {},
        name = _ref11.name;

    return name;
  };

  EditableView.prototype.renderHeader = function renderHeader() {

    return _react2.default.createElement(
      _Typography2.default,
      {
        variant: 'title'
      },
      this.getTitle(),
      this.getButtons()
    );
  };

  EditableView.prototype.renderEmpty = function renderEmpty() {
    return null;
  };

  EditableView.prototype.renderDefaultView = function renderDefaultView() {

    return null;
  };

  EditableView.prototype.renderEditableView = function renderEditableView() {

    return null;
  };

  EditableView.prototype.addError = function addError(error) {
    var _this8 = this;

    var errorDelay = this.props.errorDelay;


    if ((typeof error === 'undefined' ? 'undefined' : _typeof(error)) !== "object") {
      error = {
        message: error
      };
    }

    Object.assign(error, {
      _id: new Date().getTime()
    });

    var _state$notifications = this.state.notifications,
        notifications = _state$notifications === undefined ? [] : _state$notifications;


    notifications.push(error);

    setTimeout(function () {
      return _this8.removeError(error);
    }, errorDelay);

    this.setState({
      notifications: notifications
    });

    return error;
  };

  EditableView.prototype.removeError = function removeError(error) {
    var notifications = this.state.notifications;


    if (notifications) {

      var index = notifications.indexOf(error);

      if (index !== -1) {

        notifications.splice(index, 1);

        this.setState({
          notifications: notifications
        });
      }
    }
  };

  EditableView.prototype.closeError = function closeError(error) {

    // let {
    //   errors,
    // } = this.state;

    Object.assign(error, {
      open: false
    });

    // console.log("click event 2", error, this.state.notifications);

    this.forceUpdate();
  };

  // onCloseError(error) {

  //   let {
  //     notifications,
  //   } = this.state;

  //   if (!notifications) {
  //     return;
  //   }

  //   const index = notifications.indexOf(error);

  //   if (index !== -1) {
  //     notifications.splice(index, 1);

  //     this.setState({
  //       notifications,
  //     });
  //   }

  // }


  EditableView.prototype.renderErrors = function renderErrors() {
    var _this9 = this;

    var errorDelay = this.props.errorDelay;
    var notifications = this.state.notifications;


    if (notifications && notifications.length) {

      var output = null;

      var errors = notifications.map(function (error, index) {
        var _id = error._id,
            message = error.message,
            _error$open = error.open,
            open = _error$open === undefined ? true : _error$open;


        return _react2.default.createElement(_Snackbar2.default, {
          key: _id,
          open: open,
          autoHideDuration: errorDelay,
          SnackbarContentProps: {},
          anchorOrigin: {
            vertical: "top",
            horizontal: "center"
          },
          message: _react2.default.createElement(
            'span',
            null,
            message
          ),
          action: _react2.default.createElement(
            _react.Fragment,
            null,
            _react2.default.createElement(
              _Button2.default,
              {
                color: 'primary',
                variant: 'raised',
                size: 'small',
                onClick: function onClick(event) {
                  // console.log("click event", event.target);
                  event.stopPropagation();
                  _this9.closeError(error);
                }
              },
              '\u041E\u0442\u043C\u0435\u043D\u0430'
            )
          )
        });
      });

      var _global = global,
          document = _global.document;


      if (document.createRange) {
        output = _reactDom2.default.createPortal(_react2.default.createElement(
          _react.Fragment,
          null,
          errors
        ), window.document.body);
      } else {
        output = errors;
      }

      return output;
    } else {
      return null;
    }
  };

  EditableView.prototype.render = function render() {
    var data = this.props.data;


    if (!data) {
      return null;
    }

    var object = data.object,
        loading = data.loading;


    var output = null;

    if (!object) {

      if (loading) {
        return null;
      } else {
        output = this.renderEmpty();
      }
    } else {

      var inEditMode = this.isInEditMode();

      var content = null;

      if (inEditMode) {

        content = this.renderEditableView();
      } else {

        content = this.renderDefaultView();
      }

      output = _react2.default.createElement(
        _react.Fragment,
        null,
        this.renderHeader(),
        content
      );
    }

    return _react2.default.createElement(
      _react.Fragment,
      null,
      output,
      this.renderErrors()
    );
  };

  return EditableView;
}(_2.default), _class.propTypes = _extends({}, _2.default.propTypes, {
  mutate: _propTypes2.default.func.isRequired,
  _dirty: _propTypes2.default.object,
  errorDelay: _propTypes2.default.number.isRequired,
  SaveIcon: _propTypes2.default.func.isRequired,
  ResetIcon: _propTypes2.default.func.isRequired,
  EditIcon: _propTypes2.default.func.isRequired,
  cacheKey: _propTypes2.default.string,
  cacheKeyPrefix: _propTypes2.default.string.isRequired
}), _class.defaultProps = _extends({}, _2.default.defaultProps, {
  errorDelay: 10000,
  SaveIcon: SaveIcon,
  ResetIcon: _Restore2.default,
  EditIcon: _ModeEdit2.default,
  cacheKeyPrefix: "item_"
}), _temp);
exports.default = EditableView;
module.exports = exports['default'];