'use strict';

exports.__esModule = true;
exports.TableView = exports.styles = exports.DevTableView = exports.data = exports.limit = exports.count = exports.edges = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Grid = require('material-ui/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Table = require('../../../../DataView/List/Table');

var _withStyles = require('material-ui/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var edges = exports.edges = [{
  "node": {
    "id": "cjn27lkhv08sp0950dcfp61c3",
    "username": "Test",
    "fullname": "",
    "image": null,
    "sudo": false,
    "email": "test@localhost",
    "__typename": "User"
  },
  "__typename": "UserEdge"
}, {
  "node": {
    "id": "cjn29andg08zb0950gba9l3yo",
    "username": "test",
    "fullname": null,
    "image": null,
    "sudo": false,
    "__typename": "User"
  },
  "__typename": "UserEdge"
}];

var count = exports.count = edges.length;

var limit = exports.limit = 1;

var data = exports.data = {
  "variables": {
    "first": 10,
    "skip": 0,
    "orderBy": "username_ASC",
    "where": null
  },
  "loading": false,
  "networkStatus": 7,
  "objectsConnection": {
    "pageInfo": {
      "hasNextPage": false,
      "hasPreviousPage": false,
      "startCursor": "cjn27lkhv08sp0950dcfp61c3",
      "endCursor": "cjn29b63508zn09504gf24kde",
      "__typename": "PageInfo"
    },
    "aggregate": {
      "count": count,
      "__typename": "AggregateUser"
    },
    "edges": edges,
    "__typename": "UserConnection"
  }
};

var DevTableView = exports.DevTableView = (_temp = _class = function (_TableView) {
  _inherits(DevTableView, _TableView);

  function DevTableView(props) {
    _classCallCheck(this, DevTableView);

    var _this = _possibleConstructorReturn(this, _TableView.call(this, props));

    _this.state = _extends({}, _this.state, {
      columnData: [{
        id: "id",
        label: "ID",
        hidden: true
      }, {
        id: "username",
        label: "Username",
        description: "Unique username",
        hidden: false,
        renderer: function renderer(value) {
          return _react2.default.createElement(
            'span',
            {
              className: 'username'
            },
            value
          );
        }
      }, {
        id: "email",
        label: "Email",
        hidden: false,
        renderer: function renderer(value) {
          return value ? _react2.default.createElement(
            'a',
            {
              href: 'mailto:' + value
            },
            value
          ) : null;
        }
      }]
    });
    return _this;
  }

  DevTableView.prototype.renderFilters = function renderFilters() {
    var _this2 = this;

    _objectDestructuringEmpty(this.props);

    var _ref = this.getFilters() || {},
        query = _ref.query,
        advantages_not = _ref.advantages_not,
        with_employes = _ref.with_employes;

    var filters = _react2.default.createElement(
      _Grid2.default,
      {
        container: true,
        spacing: 8,
        alignItems: 'center'
      },
      _react2.default.createElement(
        _Grid2.default,
        {
          item: true
        },
        _react2.default.createElement(_TextField2.default, {
          label: '\u041F\u043E\u0438\u0441\u043A',
          style: {
            marginLeft: 10,
            width: 200
          },
          name: 'query',
          value: query || "",
          onChange: function onChange(event) {
            var value = event.target.value;


            _this2.setFilters({
              query: value
            });
          },
          inputProps: {
            className: "searchInput"
          }
        })
      ),
      _react2.default.createElement(
        _Grid2.default,
        {
          item: true
        },
        _react2.default.createElement(
          _Grid2.default,
          {
            container: true,
            alignItems: 'center'
          },
          _react2.default.createElement(
            _Grid2.default,
            {
              item: true
            },
            _react2.default.createElement(_Checkbox2.default, {
              checked: advantages_not === null ? true : false,
              bool: 'true',
              onChange: function onChange(event, checked) {
                // const {
                //   value,
                // } = event.target;

                _this2.setFilters({
                  advantages_not: checked ? null : undefined
                });
              }
            })
          ),
          _react2.default.createElement(
            _Grid2.default,
            {
              item: true
            },
            '\u0421 \u043F\u0440\u0435\u0438\u043C\u0443\u0449\u0435\u0441\u0442\u0432\u0430\u043C\u0438'
          )
        )
      ),
      _react2.default.createElement(
        _Grid2.default,
        {
          item: true
        },
        _react2.default.createElement(
          _Grid2.default,
          {
            container: true,
            alignItems: 'center'
          },
          _react2.default.createElement(
            _Grid2.default,
            {
              item: true
            },
            _react2.default.createElement(_Checkbox2.default, {
              checked: with_employes === true ? true : false,
              bool: 'true',
              onChange: function onChange(event, checked) {
                _this2.setFilters({
                  with_employes: checked ? true : undefined
                });
              }
            })
          ),
          _react2.default.createElement(
            _Grid2.default,
            {
              item: true
            },
            '\u0421 \u0441\u043E\u0442\u0440\u0443\u0434\u043D\u0438\u043A\u0430\u043C\u0438'
          )
        )
      ),
      _react2.default.createElement(
        _Grid2.default,
        {
          item: true
        },
        _react2.default.createElement(
          _Button2.default,
          {
            onClick: function onClick(event) {
              return _this2.cleanFilters({
                // where: null,
                // extraWhere: null,
              });
            }
          },
          '\u0421\u0431\u0440\u043E\u0441'
        )
      )
    );

    return filters;
  };

  DevTableView.prototype.getColumns = function getColumns() {
    var columnData = this.state.columnData;


    return columnData || [];
  };

  return DevTableView;
}(_Table.TableView), _class.defaultProps = _extends({}, _Table.TableView.defaultProps, {
  data: data,
  title: "Test",
  limit: limit

}), _temp);
exports.styles = _Table.styles;
exports.TableView = DevTableView;
exports.default = (0, _withStyles2.default)(_Table.styles)(function (props) {
  return _react2.default.createElement(DevTableView, props);
});